package javax.management;

import javax.management.loading.ClassLoaderRepository;
import java.io.ObjectInputStream;
import java.util.Set;

public interface MBeanServer extends MBeanServerConnection
{
    public abstract ObjectInstance createMBean(String p0, ObjectName p1) throws ReflectionException, InstanceAlreadyExistsException, MBeanRegistrationException, MBeanException, NotCompliantMBeanException;
    
    public abstract ObjectInstance createMBean(String p0, ObjectName p1, ObjectName p2) throws ReflectionException, InstanceAlreadyExistsException, MBeanRegistrationException, MBeanException, NotCompliantMBeanException, InstanceNotFoundException;
    
    public abstract ObjectInstance createMBean(String p0, ObjectName p1, Object[] p2, String[] p3) throws ReflectionException, InstanceAlreadyExistsException, MBeanRegistrationException, MBeanException, NotCompliantMBeanException;
    
    public abstract ObjectInstance createMBean(String p0, ObjectName p1, ObjectName p2, Object[] p3, String[] p4) throws ReflectionException, InstanceAlreadyExistsException, MBeanRegistrationException, MBeanException, NotCompliantMBeanException, InstanceNotFoundException;
    
    public abstract ObjectInstance registerMBean(Object p0, ObjectName p1) throws InstanceAlreadyExistsException, MBeanRegistrationException, NotCompliantMBeanException;
    
    public abstract void unregisterMBean(ObjectName p0) throws InstanceNotFoundException, MBeanRegistrationException;
    
    public abstract ObjectInstance getObjectInstance(ObjectName p0) throws InstanceNotFoundException;
    
    public abstract Set<ObjectInstance> queryMBeans(ObjectName p0, QueryExp p1);
    
    public abstract Set<ObjectName> queryNames(ObjectName p0, QueryExp p1);
    
    public abstract boolean isRegistered(ObjectName p0);
    
    public abstract Integer getMBeanCount();
    
    public abstract Object getAttribute(ObjectName p0, String p1) throws MBeanException, AttributeNotFoundException, InstanceNotFoundException, ReflectionException;
    
    public abstract AttributeList getAttributes(ObjectName p0, String[] p1) throws InstanceNotFoundException, ReflectionException;
    
    public abstract void setAttribute(ObjectName p0, Attribute p1) throws InstanceNotFoundException, AttributeNotFoundException, InvalidAttributeValueException, MBeanException, ReflectionException;
    
    public abstract AttributeList setAttributes(ObjectName p0, AttributeList p1) throws InstanceNotFoundException, ReflectionException;
    
    public abstract Object invoke(ObjectName p0, String p1, Object[] p2, String[] p3) throws InstanceNotFoundException, MBeanException, ReflectionException;
    
    public abstract String getDefaultDomain();
    
    public abstract String[] getDomains();
    
    public abstract void addNotificationListener(ObjectName p0, NotificationListener p1, NotificationFilter p2, Object p3) throws InstanceNotFoundException;
    
    public abstract void addNotificationListener(ObjectName p0, ObjectName p1, NotificationFilter p2, Object p3) throws InstanceNotFoundException;
    
    public abstract void removeNotificationListener(ObjectName p0, ObjectName p1) throws InstanceNotFoundException, ListenerNotFoundException;
    
    public abstract void removeNotificationListener(ObjectName p0, ObjectName p1, NotificationFilter p2, Object p3) throws InstanceNotFoundException, ListenerNotFoundException;
    
    public abstract void removeNotificationListener(ObjectName p0, NotificationListener p1) throws InstanceNotFoundException, ListenerNotFoundException;
    
    public abstract void removeNotificationListener(ObjectName p0, NotificationListener p1, NotificationFilter p2, Object p3) throws InstanceNotFoundException, ListenerNotFoundException;
    
    public abstract MBeanInfo getMBeanInfo(ObjectName p0) throws InstanceNotFoundException, IntrospectionException, ReflectionException;
    
    public abstract boolean isInstanceOf(ObjectName p0, String p1) throws InstanceNotFoundException;
    
    public abstract Object instantiate(String p0) throws ReflectionException, MBeanException;
    
    public abstract Object instantiate(String p0, ObjectName p1) throws ReflectionException, MBeanException, InstanceNotFoundException;
    
    public abstract Object instantiate(String p0, Object[] p1, String[] p2) throws ReflectionException, MBeanException;
    
    public abstract Object instantiate(String p0, ObjectName p1, Object[] p2, String[] p3) throws ReflectionException, MBeanException, InstanceNotFoundException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(ObjectName p0, byte[] p1) throws InstanceNotFoundException, OperationsException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(String p0, byte[] p1) throws OperationsException, ReflectionException;
    
    @Deprecated
    public abstract ObjectInputStream deserialize(String p0, ObjectName p1, byte[] p2) throws InstanceNotFoundException, OperationsException, ReflectionException;
    
    public abstract ClassLoader getClassLoaderFor(ObjectName p0) throws InstanceNotFoundException;
    
    public abstract ClassLoader getClassLoader(ObjectName p0) throws InstanceNotFoundException;
    
    public abstract ClassLoaderRepository getClassLoaderRepository();
}
